﻿
(function () {

	var stylename = 'sidenote';
	var frames;
	var sidenotes;


	function find_frames_with_sidenotes () {
		var frame;
		app.findObjectPreferences = null;
		app.findObjectPreferences.appliedObjectStyles = app.documents[0].objectStyles.item (stylename);
		var f = app.documents[0].findObject();
		var known = [];
		var list = [];
		for (var i = 0; i < f.length; i++){
			try {
				frame = f[i].parent.parentTextFrames[0];
				if (!known[frame.id]) {
					list.push (frame);
					known[frame.id] = true;
				}
			} catch (_) {
			}
		}
		return list;
	}



	function get_sidenotes (tf) {
		var notes = [];
		var f = tf.textFrames.everyItem().getElements();
		for (var i = 0; i < f.length; i++) {
			if (f[i].appliedObjectStyle.name == stylename) {
				notes.push (f[i]);
			}
		}
		return notes;
	}


	function height (frame) {
		return frame.geometricBounds[2] - frame.geometricBounds[0];
	}


	function resolveOverlaps (frames, bottom) {
		var moved;
		var overlap;

		for (var i = 0; i < frames.length - 1; i++) {
			overlap = frames[i].geometricBounds[2] - frames[i+1].geometricBounds[0];
			if (overlap > 0) {
				if (frames[i].geometricBounds[2] + height (frames[i+1]) + overlap <= bottom) {
					frames[i+1].move (undefined, [0, overlap+3]);
				} else {
					break;
				}
			}
		}
	}

	//========================================================

	if (app.selection.length === 0) {
		frames = find_frames_with_sidenotes();
	} else if (app.selection[0] instanceof TextFrame) {
		frames = [app.selection[0]];
	} else {
		alert ('Select nothing or a single text frame');
		exit();
	}

	for (var i = 0; i < frames.length; i++) {
		sidenotes = get_sidenotes (frames[i]);
		if (sidenotes.length > 1) {
			resolveOverlaps (sidenotes, frames[i].geometricBounds[2]);
		}
	}

}());