﻿

(function () {
	
	var i;
	var frame;
	var notes;
	
	var indd = app.documents[0];
	var oStyleOutside = indd.objectStyles.item('sidenote');
	var oStyleInside;
	
	app.scriptPreferences.measurementUnit = MeasurementUnits.POINTS;


	function duplicateObjectStyle () {
		var os = indd.objectStyles.item ('sidenote-inside');
		if (!os.isValid) {
			var pstyle = indd.objectStyles.item('sidenote').appliedParagraphStyle;
			var pstyleDuped = pstyle.duplicate();
			pstyleDuped.name = pstyle.name + '-inside';
			pstyleDuped.justification = Justification.AWAY_FROM_BINDING_SIDE;
			
			os = indd.objectStyles.item('sidenote').duplicate();
			os.properties = {
				name: 'sidenote-inside',
				appliedParagraphStyle: pstyleDuped,
				anchoredObjectSettings: {
					anchorPoint: AnchorPoint.TOP_LEFT_ANCHOR,
					horizontalAlignment: HorizontalAlignment.RIGHT_ALIGN,
				}
			}
		}
		return os;
	}


	function findNotes () {
		app.findObjectPreferences = null;
		app.findObjectPreferences.appliedObjectStyles = indd.objectStyles.item ('sidenote');
		var notes = indd.findObject();
		app.findObjectPreferences.appliedObjectStyles = indd.objectStyles.item ('sidenote-inside');
		notes = notes.concat (indd.findObject());
		return notes;
	}


	function isInside (frame, ch) {
		var gb = frame.geometricBounds;
		var centre = gb[1] + ((gb[3] - gb[1]) / 2);

		return (frame.parentPage.side === PageSideOptions.LEFT_HAND && ch.horizontalOffset > centre)
			|| (frame.parentPage.side === PageSideOptions.RIGHT_HAND && ch.horizontalOffset < centre);
	}


	oStyleInside = duplicateObjectStyle();
	notes = findNotes();
	for (i = 0; i < notes.length; i++) {
		try {
			frame = notes[i].parent.parentTextFrames[0];
			if (frame.textFramePreferences.textColumnCount === 1) {
				notes[i].appliedObjectStyle = oStyleOutside;
			} else if (isInside (frame, notes[i].parent)) {
				notes[i].appliedObjectStyle = oStyleInside;
			} else {
				notes[i].appliedObjectStyle = oStyleOutside;
			}
		} catch (_) {
		}
	}

}());